Index: trunk/external-alma/atnf/PKSIO/NROOTFDataset.cc
===================================================================
--- trunk/external-alma/atnf/PKSIO/NROOTFDataset.cc	(revision 2781)
+++ trunk/external-alma/atnf/PKSIO/NROOTFDataset.cc	(revision 2782)
@@ -41,110 +41,37 @@
 NROOTFDataset::NROOTFDataset( string name )
   : NRODataset( name ) 
-{
-  LogIO os( LogOrigin( "NROOTFDataset", "NROOTFDataset()", WHERE ) ) ;
-
-  // check endian
-  open() ;
-  fseek( fp_, 144, SEEK_SET ) ;
-  int tmp ;
-  if( fread( &tmp, 1, sizeof(int), fp_ ) != sizeof(int) ) {
-    os << LogIO::SEVERE << "Error while checking endian of the file. " << LogIO::EXCEPTION ;
-    return ;
-  }
-  if ( ( 0 < tmp ) && ( tmp <= NRO_ARYMAX ) ) {
-    same_ = 1 ;
-    os << LogIO::NORMAL << "same endian " << LogIO::POST ;
-  }
-  else {
-    same_ = 0 ;
-    os << LogIO::NORMAL << "different endian " << LogIO::POST ;
-  }
-  fseek( fp_, 0, SEEK_SET ) ;
- 
-  // memory allocation
-  initialize() ;
-
-  // data initialization
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
-    DSBFC[i] = 1.0 ;
-  }
-}
+{}
 
 // destructor 
 NROOTFDataset::~NROOTFDataset() 
-{
-}
+{}
 
 // data initialization
 void NROOTFDataset::initialize()
 {
-  RX.resize( NRO_ARYMAX ) ;
-  HPBW.resize( NRO_ARYMAX ) ;
-  EFFA.resize( NRO_ARYMAX ) ;
-  EFFB.resize( NRO_ARYMAX ) ;
-  EFFL.resize( NRO_ARYMAX ) ;
-  EFSS.resize( NRO_ARYMAX ) ;
-  GAIN.resize( NRO_ARYMAX ) ;
-  HORN.resize( NRO_ARYMAX ) ;
-  POLTP.resize( NRO_ARYMAX ) ;
-  POLDR.resize( NRO_ARYMAX ) ;
-  POLAN.resize( NRO_ARYMAX ) ;
-  DFRQ.resize( NRO_ARYMAX ) ;
-  SIDBD.resize( NRO_ARYMAX ) ;
-  REFN.resize( NRO_ARYMAX ) ;
-  IPINT.resize( NRO_ARYMAX ) ;
-  MULTN.resize( NRO_ARYMAX ) ;
-  MLTSCF.resize( NRO_ARYMAX ) ;
-  LAGWIND.resize( NRO_ARYMAX ) ;
-  BEBW.resize( NRO_ARYMAX ) ;
-  BERES.resize( NRO_ARYMAX ) ;
-  CHWID.resize( NRO_ARYMAX ) ;
-  ARRY.resize( NRO_ARYMAX ) ;
-  NFCAL.resize( NRO_ARYMAX ) ;
-  F0CAL.resize( NRO_ARYMAX ) ;
-  FQCAL.resize( NRO_ARYMAX ) ;
-  CHCAL.resize( NRO_ARYMAX ) ;
-  CWCAL.resize( NRO_ARYMAX ) ;
-  DSBFC.resize( NRO_ARYMAX ) ;
+  int arymax = arrayMax() ;
+
+  // it must be called
+  NRODataset::initialize() ;
+  
+  // additional initialization
+  datasize_ += sizeof( char ) * arymax * 16 // RX
+    + sizeof( double ) * arymax * 6         // HPBW, EFFA, EFFB, EFFL, EFSS GAIN
+    + sizeof( char ) * arymax * 4           // HORN
+    + sizeof( char ) * arymax * 4           // POLTP
+    + sizeof( double ) * arymax * 3         // POLDR, POLAN, DFRQ
+    + sizeof( char ) * arymax * 4           // SIDBID
+    + sizeof( int ) * arymax * 3            // REFN, IPINT, MULTN
+    + sizeof( double ) * arymax             // MLTSCF
+    + sizeof( char ) * arymax * 8           // LAGWIND
+    + sizeof( double ) * arymax * 3         // BEBW, BERES, CHWID
+    + sizeof( int ) * arymax * 2            // ARRY, NFCAL
+    + sizeof( double ) * arymax             // F0CAL
+    + sizeof( double ) * arymax * 10 * 3    // FQCAL, CHCAL, CWCAL
+    + sizeof( char ) * 180 ;                    // CDMY1
 
   for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
-    FQCAL[i].resize( 10 ) ;
-    CHCAL[i].resize( 10 ) ;
-    CWCAL[i].resize( 10 ) ;
-  }
-
-  datasize_ += sizeof( char ) * NRO_ARYMAX * 16 // RX
-    + sizeof( double ) * NRO_ARYMAX * 6         // HPBW, EFFA, EFFB, EFFL, EFSS GAIN
-    + sizeof( char ) * NRO_ARYMAX * 4           // HORN
-    + sizeof( char ) * NRO_ARYMAX * 4           // POLTP
-    + sizeof( double ) * NRO_ARYMAX * 3         // POLDR, POLAN, DFRQ
-    + sizeof( char ) * NRO_ARYMAX * 4           // SIDBID
-    + sizeof( int ) * NRO_ARYMAX * 3            // REFN, IPINT, MULTN
-    + sizeof( double ) * NRO_ARYMAX             // MLTSCF
-    + sizeof( char ) * NRO_ARYMAX * 8           // LAGWIND
-    + sizeof( double ) * NRO_ARYMAX * 3         // BEBW, BERES, CHWID
-    + sizeof( int ) * NRO_ARYMAX * 2            // ARRY, NFCAL
-    + sizeof( double ) * NRO_ARYMAX             // F0CAL
-    + sizeof( double ) * NRO_ARYMAX * 10 * 3    // FQCAL, CHCAL, CWCAL
-    + sizeof( char ) * 180 ;                    // CDMY1
-
-  refFreq_.resize( NRO_ARYMAX, 0.0 ) ;
-}
-
-// fill data header
-int NROOTFDataset::fillHeader() 
-{
-  LogIO os( LogOrigin( "NROOTFDataset", "fillHeader()", WHERE ) ) ;
-
-  // open file
-  if ( open() ) {
-    os << LogIO::SEVERE << "Error opening file " << filename_ << "." << LogIO::EXCEPTION ;
-    return -1 ;
-  }
-
-  // fill
-  int status = fillHeader( same_ ) ;
-
-  return status ;
+    DSBFC[i] = 1.0 ;
+  }
 }
 
@@ -152,4 +79,6 @@
 {
   LogIO os( LogOrigin( "NROOTFDataset", "fillHeader()", WHERE ) ) ;
+
+  int arymax = arrayMax() ;
 
   string str4( 4, ' ' ) ;
@@ -527,5 +456,5 @@
   //cout << "PA = " << PA << endl ;
   //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
+  for ( int i = 0 ; i < arymax ; i++ ) {
     strcpy( c18, str18.c_str() ) ;
     if ( readHeader( c18, 16 ) == -1 ) {
@@ -537,7 +466,7 @@
   }
   // DEBUG
-//   nro_debug_output( "RX", NRO_ARYMAX, RX ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
+//   nro_debug_output( "RX", arymax, RX ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++ ) {
     if ( readHeader( HPBW[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data HPBW[" << i << "]." << LogIO::POST ;
@@ -546,7 +475,7 @@
   }
   // DEBUG
-//   nro_debug_output( "HPBW", NRO_ARYMAX, HPBW ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
+//   nro_debug_output( "HPBW", arymax, HPBW ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++ ) {
     if ( readHeader( EFFA[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data EFFA[" << i << "]." << LogIO::POST ;
@@ -555,7 +484,7 @@
   }
   // DEBUG
-//   nro_debug_output( "EFFA", NRO_ARYMAX, EFFA ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
+//   nro_debug_output( "EFFA", arymax, EFFA ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++ ) {
     if ( readHeader( EFFB[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data EFFB[" << i << "]." << LogIO::POST ;
@@ -564,7 +493,7 @@
   }
   // DEBUG
-//   nro_debug_output( "EFFB", NRO_ARYMAX, EFFB ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
+//   nro_debug_output( "EFFB", arymax, EFFB ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++ ) {
     if ( readHeader( EFFL[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data EFFL[" << i << "]." << LogIO::POST ;
@@ -573,7 +502,7 @@
   }
   // DEBUG
-//   nro_debug_output( "EFFL", NRO_ARYMAX, EFFL ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++ ) {
+//   nro_debug_output( "EFFL", arymax, EFFL ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++ ) {
     if ( readHeader( EFSS[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data EFSS[" << i << "]." << LogIO::POST ;
@@ -582,7 +511,7 @@
   }
   // DEBUG
-//   nro_debug_output( "EFSS", NRO_ARYMAX, EFSS ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "EFSS", arymax, EFSS ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( GAIN[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data GAIN[" << i << "]." << LogIO::POST ;
@@ -591,7 +520,7 @@
   }
   // DEBUG
-//   nro_debug_output( "GAIN", NRO_ARYMAX, GAIN ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "GAIN", arymax, GAIN ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     strcpy( c4, str4.c_str() ) ;
     if ( readHeader( c4, 4 ) == -1 ) {
@@ -602,7 +531,7 @@
   }
   // DEBUG
-//   nro_debug_output( "HORN", NRO_ARYMAX, HORN ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "HORN", arymax, HORN ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     strcpy( c4, str4.c_str() ) ;
     if ( readHeader( c4, 4 ) == -1 ) {
@@ -613,7 +542,7 @@
   }
   // DEBUG
-//   nro_debug_output( "POLTP", NRO_ARYMAX, POLTP ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "POLTP", arymax, POLTP ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( POLDR[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data POLDR[" << i << "]." << LogIO::POST ;
@@ -622,7 +551,7 @@
   }
   // DEBUG
-//   nro_debug_output( "POLDR", NRO_ARYMAX, POLDR ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "POLDR", arymax, POLDR ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( POLAN[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data POLAN[" << i << "]." << LogIO::POST ;
@@ -631,7 +560,7 @@
   }
   // DEBUG
-//   nro_debug_output( "POLAN", NRO_ARYMAX, POLAN ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "POLAN", arymax, POLAN ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( DFRQ[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data DFRQ[" << i << "]." << LogIO::POST ;
@@ -640,7 +569,7 @@
   }
   // DEBUG
-//   nro_debug_output( "DFRQ", NRO_ARYMAX, DFRQ ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "DFRQ", arymax, DFRQ ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     strcpy( c4, str4.c_str() ) ;
     if ( readHeader( c4, 4 ) == -1 ) {
@@ -651,7 +580,7 @@
   }
   // DEBUG
-//   nro_debug_output( "SIDBD", NRO_ARYMAX, SIDBD ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "SIDBD", arymax, SIDBD ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( REFN[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data REFN[" << i << "]." << LogIO::POST ;
@@ -660,7 +589,7 @@
   }
   // DEBUG
-//   nro_debug_output( "REFN", NRO_ARYMAX, REFN ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "REFN", arymax, REFN ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( IPINT[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data IPINT[" << i << "]." << LogIO::POST ;
@@ -669,7 +598,7 @@
   }
   // DEBUG
-//   nro_debug_output( "IPINT", NRO_ARYMAX, IPINT ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "IPINT", arymax, IPINT ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( MULTN[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data MULTN[" << i << "]." << LogIO::POST ;
@@ -678,7 +607,7 @@
   }
   // DEBUG
-//   nro_debug_output( "MULTN", NRO_ARYMAX, MULTN ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "MULTN", arymax, MULTN ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( MLTSCF[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data MLTSCF[" << i << "]." << LogIO::POST ;
@@ -687,7 +616,7 @@
   }
   // DEBUG
-//   nro_debug_output( "MLTSCF", NRO_ARYMAX, MLTSCF ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "MLTSCF", arymax, MLTSCF ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     strcpy( c8, str8.c_str() ) ;
     if ( readHeader( c8, 8 ) == -1 ) {
@@ -698,7 +627,7 @@
   }
   // DEBUG
-//   nro_debug_output( "LAGWIND", NRO_ARYMAX, LAGWIND ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "LAGWIND", arymax, LAGWIND ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( BEBW[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data BEBW[" << i << "]." << LogIO::POST ;
@@ -707,7 +636,7 @@
   }
   // DEBUG
-//   nro_debug_output( "BEBW", NRO_ARYMAX, BEBW ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "BEBW", arymax, BEBW ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( BERES[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data BERES[" << i << "]." << LogIO::POST ;
@@ -716,7 +645,7 @@
   }
   // DEBUG
-//   nro_debug_output( "BERES", NRO_ARYMAX, BERES ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "BERES", arymax, BERES ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( CHWID[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data CHWID[" << i << "]." << LogIO::POST ;
@@ -725,7 +654,7 @@
   }
   // DEBUG
-//   nro_debug_output( "CHWID", NRO_ARYMAX, CHWID ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "CHWID", arymax, CHWID ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( ARRY[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data ARRY[" << i << "]." << LogIO::POST ;
@@ -734,7 +663,7 @@
   }
   // DEBUG
-//   nro_debug_output( "ARRY", NRO_ARYMAX, ARRY ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "ARRY", arymax, ARRY ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( NFCAL[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data NFCAL[" << i << "]." << LogIO::POST ;
@@ -743,7 +672,7 @@
   }
   // DEBUG
-//   nro_debug_output( "NFCAL", NRO_ARYMAX, NFCAL ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "NFCAL", arymax, NFCAL ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     if ( readHeader( F0CAL[i], sameEndian ) == -1 ) {
       os << LogIO::WARN << "Error while reading data F0CAL[" << i << "]." << LogIO::POST ;
@@ -752,7 +681,7 @@
   }
   // DEBUG
-//   nro_debug_output( "F0CAL", NRO_ARYMAX, F0CAL ) ;
-  //
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+//   nro_debug_output( "F0CAL", arymax, F0CAL ) ;
+  //
+  for ( int i = 0 ; i < arymax ; i++) {
     for ( int j = 0 ; j < 10 ; j++ ) {
       if ( readHeader( FQCAL[i][j], sameEndian ) == -1 ) {
@@ -763,7 +692,7 @@
   }
   // DEBUG
-//   nro_debug_output( "FQCAL", NRO_ARYMAX, 10, FQCAL ) ;
+//   nro_debug_output( "FQCAL", arymax, 10, FQCAL ) ;
   //  
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+  for ( int i = 0 ; i < arymax ; i++) {
     for ( int j = 0 ; j < 10 ; j++ ) {
       if ( readHeader( CHCAL[i][j], sameEndian ) == -1 ) {
@@ -774,7 +703,7 @@
   }
   // DEBUG
-//   nro_debug_output( "CHCAL", NRO_ARYMAX, 10, CHCAL ) ;
+//   nro_debug_output( "CHCAL", arymax, 10, CHCAL ) ;
   //  
-  for ( int i = 0 ; i < NRO_ARYMAX ; i++) {
+  for ( int i = 0 ; i < arymax ; i++) {
     for ( int j = 0 ; j < 10 ; j++ ) {
       if ( readHeader( CWCAL[i][j], sameEndian ) == -1 ) {
@@ -785,5 +714,5 @@
   }
   // DEBUG
-//   nro_debug_output( "CWCAL", NRO_ARYMAX, 10, CWCAL ) ;
+//   nro_debug_output( "CWCAL", arymax, 10, CWCAL ) ;
   //  
   if ( readHeader( SCNLEN, sameEndian ) == -1 ) {
@@ -828,16 +757,4 @@
   //
 
-  //scanNum_ = NSCAN + 1 ; // includes ZERO scan
-  scanLen_ = SCNLEN ;
-  dataLen_ = scanLen_ - SCAN_HEADER_SIZE ;
-  scanNum_ = getScanNum();
-  rowNum_ = scanNum_ * ARYNM ;
-  chmax_ = (int) ( dataLen_ * 8 / IBIT ) ;
-  record_->LDATA = new char[dataLen_] ;
-
-  initArray();
-
-  show() ;
-
   return 0 ;
 }
